/*
 KeywordSkew.java
 Copyright (C) 2003 Gerardo Horvilleur Martinez

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.parser.keywords;

import net.cellcomputing.himawari.library.RendermanInterface;
import net.cellcomputing.himawari.parser.Tokenizer;

public strictfp class KeywordSkew extends AbstractKeywordParser {
    

    public void parse(Tokenizer st) throws Exception {
        boolean array = false;
        int token = st.nextToken();
        // Check por array
        if (token == TK_LBRACE)
            array = true;
        else
            st.pushBack();

        // Expect angle
        match(st, TK_NUMBER);
        float angle = (float) st.nval;
        
        // Expect dx1
        match(st, TK_NUMBER);
        float dx1 = (float) st.nval;
        
        // Expect dy1
        match(st, TK_NUMBER);
        float dy1 = (float) st.nval;

        // Expect dz1
        match(st, TK_NUMBER);
        float dz1 = (float) st.nval;

        // Expect dx2
        match(st, TK_NUMBER);
        float dx2 = (float) st.nval;

        // Expect dy2
        match(st, TK_NUMBER);
        float dy2 = (float) st.nval;

        // Expect dz2
        match(st, TK_NUMBER);
        float dz2 = (float) st.nval;

        if (array)
            match(st, TK_RBRACE);
        
        RendermanInterface.RiSkew( angle, dx1, dy1, dz1, dx2, dy2, dz2 );
    }

}
