// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.shadervm;

import static net.cellcomputing.himawari.library.EqIntIndex.SHD_Var_varying_init;
import static net.cellcomputing.himawari.library.EqIntIndex.SHD_var_varying_matrix;
import net.cellcomputing.himawari.accessory.STLArray;
import net.cellcomputing.himawari.accessory.STLVector;
import net.cellcomputing.himawari.library.CqStats;
import net.cellcomputing.himawari.library.EqVariableType;
import net.cellcomputing.himawari.library.IqShaderData;
import net.cellcomputing.himawari.library.types.CqMatrix;

/**
 * CqShaderVariableVaryingNXCqMatrixɓ
 * NX
 * @author NTT DATA Corporation
 */
public strictfp class CqShaderVariableVaryingMatrix extends CqShaderVariableVarying<CqMatrix> {
	
	/**
	 * RXgN^B
	 * Vector̔z1ɃZbgāA
	 * vXVB
	 */
	public CqShaderVariableVaryingMatrix( )
	{
		super(new EqVariableType(EqVariableType.type_matrix));
		//Ϗ̂
		//m_aValue = new STLVector<CqMatrix>(CqMatrix.class);
		m_aValue = new STLArray<CqMatrix>(CqMatrix.class);
		m_aValue.resize( 1 );
		
		CqStats.STATS_INC( SHD_var_varying_matrix );
	}
	
	/**
	 * RXgN^B
	 * Vector̔z1ɃZbgāA
	 * vXVB
	 * 
	 * @param strName
	 * @param fParameter
	 */
	public CqShaderVariableVaryingMatrix( final String strName, boolean fParameter)
	{
		super(strName,fParameter,new EqVariableType(EqVariableType.type_matrix));
		//Ϗ̂
//		m_aValue = new STLVector<CqMatrix>(CqMatrix.class);
		m_aValue = new STLArray<CqMatrix>(CqMatrix.class);
		m_aValue.resize( 1 );
		CqStats.STATS_INC( SHD_var_varying_matrix );
	}
	
	/**
	 * RXgN^B
	 * Vector̔z1ɃZbgāA
	 * vXVB
	 * 
	 * @param strName
	 */
	public CqShaderVariableVaryingMatrix( final String strName){
		this(strName,false);
	}
	
	/**
	 * Rs[RXgN^
	 * @param val
	 */
	public CqShaderVariableVaryingMatrix(CqShaderVariableVaryingMatrix val){
		super(val,new EqVariableType(EqVariableType.type_matrix));
//		m_aValue = new STLVector<CqMatrix>(CqMatrix.class);
		m_aValue = new STLArray<CqMatrix>(CqMatrix.class);
		m_aValue.resize( val.m_aValue.size() );
//		m_aValue.assign( val.m_aValue.begin(), val.m_aValue.begin() );
		//R[hɏC 2005/11/2 nttdata
		for(int i = 0; i < val.m_aValue.size(); i++)
			m_aValue.elementAt(i).assignment(val.m_aValue.elementAt(i));
	}
	
	/**
	 * u=vZq̃I[o[[h
	 *  Vector̒lRs[B
	 * @param From
	 */
	public void assignment(CqShaderVariableVarying From) {
		m_aValue.resize(From.m_aValue.size());
		for(int i = 0; i < From.m_aValue.size();i++){
			m_aValue.elementAt(i).assignment((CqMatrix)From.m_aValue.elementAt(i));
		}
		
	}
	
	/**
	 * eNXŒ`ꂽ֐
	 * Vector̃TCY1ȏł
	 * w肳ꂽ擪̒lVector𖄂ߐsB
	 * Vector̃TCY0ȉł΁A
	 * lŖߐsB
	 * 
	 * ߐs(uGridRes+1) * (vGridRes)B
	 * 
	 * @param uGridRes
	 * @param vGridRes
	 */
	public void Initialise(int uGridRes, int vGridRes) {
		CqMatrix Def = new CqMatrix();
		
		if ( m_aValue.size() > 0 )
			Def.assignment(m_aValue.elementAt(0));
		m_aValue.assign( (( uGridRes + 1 ) * ( vGridRes + 1 )), Def );
		
		//܂
		CqStats.STATS_INC( SHD_Var_varying_init );
		
	}
	
	/**
	 * w肳ꂽꏊShaderData̒l擾
	 * @param res 擾li[ϐ
	 * @param index 擾ꏊ
	 */
	public	void	GetMatrix( CqMatrix res, int index) 
	{
		res.assignment(m_aValue.elementAt(index));
	}
	
	/**
	 * ShaderData̎ACqMatrix^̃|C^擾B
	 * 
	 * @param res ʂi[BgύXShaderData̒le󂯂
	 */
	public	void	GetMatrixPtr( STLVector<CqMatrix> res )
	{
		res.resize(m_aValue.size());
		for(int i=0;i < m_aValue.size();i++){
			res.setElementAt(m_aValue.elementAt(i),i);
		}
	}
	//public	STLVector<CqMatrix>	GetMatrixPtr_2( )
	public	STLArray<CqMatrix>	GetMatrixPtr_2( )
	{
		return m_aValue;
	}
	
	/**
	 * ShaderData̎w肳ꂽꏊ̒lύXB
	 * 
	 * @param m ύXl
	 * @param index ύXꏊ
	 */
	public	void	SetMatrix( final CqMatrix m, int index )
	{
		m_aValue.elementAt(index).assignment( m );
	}
	
	/**
	 * ShaderData̒lύXB
	 * Ŏw肳ꂽlVector𖄂ߐs
	 * @param m ύXl
	 */
	public	void	SetMatrix( final CqMatrix m )
	{
		m_aValue.assign( m_aValue.size(), m );
	}

	/** Copy the values from the passed variable into this, taking into account any class differences.
	 * Ŏw肳ꂽϐlARs[B
	 * Rs[̃TCY1ȉ̏ꍇ́A̒l
	 * Vector̒Rs[B
	 *  
	 * Rs[Vector̃TCY1傫
	 * Vector̃TCY菬ꍇErrorƂȂB
	 * 
	 * @param pVal The variable to copy from.
	 */
	public	void	SetValueFromVariable( final IqShaderData pVal )
	{
		int i;
		if ( pVal.Size() > 1 )
		{
			//nttdata
//			STLVector<CqMatrix>  pData = new STLVector<CqMatrix>(CqMatrix.class);
//			pVal.GetMatrixPtr( pData );
			
			//STLVector<CqMatrix>  pData ;
			STLArray<CqMatrix>  pData ;
			pData = pVal.GetMatrixPtr_2( );
			for ( i = 0; i < Size(); i++ )
				m_aValue.elementAt( i ).assignment( pData.elementAt( i ));
		}
		else
		{
			CqMatrix temp = new CqMatrix();
			pVal.GetMatrix( temp );
			m_aValue.assign( m_aValue.size(), temp );
		}
	}
	
	/** 
	 * Set the all SIMD data ased on a state vector, only indexes whose bit is set are modified.
	 * Ŏw肳ꂽϐVector̎w肳ꂽꏊ̒l
	 * gVector̓ꏊɃRs[B
	 * 
	 * AgA܂̓Rs[̎Vector̒ȏ̏ꏊw肷
	 * G[B(C++ł͓ɃG[NȂ)
	 * @param pVal Rs[ The stack entry to assign.
	 * @param index Rs[ꏊ Integer SIMD index.
	 */
	public	void	SetValueFromVariable( final IqShaderData pVal, int index )
	{
		pVal.GetMatrix( m_aValue.elementAt(index), index );
	}
	
	/**
	 * ƓlCX^XԂ
	 * 
	 * @return g̃Rs[
	 */
	public	IqShaderData Clone()
	{
		CqShaderVariableVaryingMatrix newVar = new CqShaderVariableVaryingMatrix( this );
		newVar.SetSize( (int) Size() );
		newVar.SetValueFromVariable( this );
		return ( newVar );
	}
	
}
